///////////////////////////////////////////////////////////////////////
// Nom Unite: U_Composant
// Description : Fiche de gestion des composants
// Créé par Microcelt
// Modifié le
// 27/04/2005 : gestion de l'acces ou non aux boutons finition ou type finition
//     on ne doit pas pouvoir changer la finition qd la fiche est en lecture seule
//    + prb d'affichage des libelles en tant que controleur
// 20/07/2005 : ajout du bouton copie d'un composant
///////////////////////////////////////////////////////////////////////

unit U_Composant;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
{$IFNDEF FPC}
  AdvListV, RbSplitter, UltimDBGrid, RXSplit, Mask,
{$ELSE}
  MaskEdit,
{$ENDIF}
  LCLType, Messages, Graphics, Controls, Classes, ExtCtrls,  Dialogs, DB, IBQuery,IBTable,IBUpdateSQL,
  U_ExtDBNavigator, Buttons, Forms, DBCtrls, Grids,
  u_buttons_appli,u_framework_components,
  DBGrids, u_framework_dbcomponents, ComCtrls, StdCtrls, SysUtils,  TypInfo,
  Variants, StrUtils, U_FormDico, U_OnFormInfoIni,
  JvXpButtons, U_ExtDBGrid,U_ConstMessage, U_GroupView, ImgList;

const CST_COFI_Choixfinit = 'COFI_Choixfinit' ;
      CST_COFI__TYFI      = 'COFI__TYFI' ;
      CST_COFI__FINI      = 'COFI__FINI' ;
      CST_COMP_Special    = 'COMP_Indicspecial';
type

  { TF_Composant }

  TF_Composant = class(TF_FormDico)
    nv_navigator: TExtDBNavigator;
    nv_saisie: TExtDBNavigator;
    lb_code: TFWLabel;
    lb_comm: TFWLabel;
    ed_code: TFWDBEdit;
    ed_codecom: TFWDBEdit;
    pa_1: TPanel;
    pa_2: TPanel;
    pa_3: TPanel;
    pa_4: TPanel;
    pa_5: TPanel;
    pa_Datasource: TPanel;
    SvgFormInfoIni: TOnFormInfoIni;
    spl_1: TSplitter;
    lb_lib: TFWLabel;
    gd_composant: TExtDBGrid;
    me_lib: TDBMemo;
    lb_pxactu: TFWLabel;
    ed_pxactuel: TFWDBEdit;
    lb_pxfutur: TFWLabel;
    ed_pxfutur: TFWDBEdit;
    ed_coefcubage: TFWDBEdit;
    lb_coef: TFWLabel;
    ed_cubage: TFWDBEdit;
    lb_cubage: TFWLabel;
    lb_poids: TFWLabel;
    ed_poids: TFWDBEdit;
    ed_Libcom: TFWDBEdit;
    Label2: TFWLabel;
    DBMemo1: TDBMemo;
    Label3: TFWLabel;
    Panel1: TPanel;
    Panel11: TPanel;
    bt_apercu: TFWPreview;
    Panel2: TPanel;
    bt_imprimer: TFWPrint;
    Panel5: TPanel;
    Panel6: TPanel;
    dbtn_fermer: TFWClose;
    im_images: TImageList;
    bt_copiecomp: TFWCopy;
    procedure F_FormDicoCreate(Sender: TObject);
    procedure F_FormDicoClose(Sender: TObject; var Action: TCloseAction);
    procedure F_FormDicoDestroy(Sender: TObject);
    procedure lsv_CompoInDBOnRecorded(DataSet: TDataSet);
    procedure F_FormDicoDataDBSourcescroll(DataSet: TDataSet);
    procedure nv_saisieClick(Sender: TObject; Button: TExtNavigateBtn);

  private
    { Déclarations privées }
    ls_LabelFinition : WideString ;

  public
    { Déclarations publiques }
    gb_Appelle   ,
    gb_Valide    : Boolean ;
    procedure Loaded; override;
  end;

var
  F_Composant: TF_Composant;

implementation

{$IFNDEF FPC}
  {$R *.dfm}
{$ELSE}
  {$R *.lfm}
{$ENDIF}

uses fonctions_string,
     unite_messages  , U_DmCompose ,
     U_DmDonn, fonctions_db ,
     fonctions_erreurs,
     fonctions_dbobjects,
     fonctions_manbase,
     fonctions_dbcomponents;

procedure TF_Composant.F_FormDicoCreate(Sender: TObject);
begin
  gb_Appelle := False ;
  gb_Valide  := False ;
  F_Composant := Self;

end;

procedure TF_Composant.F_FormDicoClose(Sender: TObject;
  var Action: TCloseAction);
begin
  if gb_Appelle Then
    Action := caHide ;
  with M_DmCompose.zq_composant.Transaction do
   if Active Then
    Commit;
end;

procedure TF_Composant.F_FormDicoDestroy(Sender: TObject);
begin
  F_Composant := nil ;

end;

procedure TF_Composant.lsv_CompoInDBOnRecorded(DataSet: TDataSet);
begin
  fb_RefreshDataset ( M_DmCompose.zq_Composant );
end;

procedure TF_Composant.Loaded;
begin
  
  with DBSources.Add do
    Begin
      Table:='COMPOSANT';
      With Indexes.add do
       Begin
        FieldsDefs.Add.FieldName :='COMP_Clep';
        IndexKind := ikPrimary;
       end;
      Key.Add.FieldName :='COMP_Clep';
      Grid := gd_composant;
      NavEdit:=nv_saisie;
      Navigator:=nv_navigator;
      Panels.Add.Panel:=pa_Datasource;
    end;
  inherited;
end;

procedure TF_Composant.F_FormDicoDataDBSourcescroll(DataSet: TDataSet);
begin
  // rafraichissement des données couleurs - utile pour la copie de composant
  M_DmCompose.zq_CompCoul.Close;
  M_DmCompose.zq_CompCoul.Open;

  bt_copiecomp.Enabled := not (M_DmCompose.zq_Composant.FieldByName(CST_COMP_Special).AsBoolean);

end;

procedure TF_Composant.nv_saisieClick(Sender: TObject; Button: TExtNavigateBtn);
begin

end;

end.

