////////////////////////////////////
{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          VirtualDBTreeEx GPL                       }
{           Source Language:  Francais, English                         }
{           Auteurs :                                                   }
{    Copyright Matthieu Giroux from 2008 to 2016 (LAZARUS),             }
{    Copyright Microcelt 2006,                                          }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestromania est un Logiciel Libre.                        }
{                                                                       }
{ This program is free software: you can redistribute it and/or modify  }
{ it under the terms of the GNU General Public License as published by  }
{ the Free Software Foundation, either version 3 of the License, or     }
{ (at your option) any later version.                                   }
{                                                                       }
{ This program is distributed in the hope that it will be useful,       }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of        }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         }
{ GNU General Public License for more details.                          }
{                                                                       }
{ You should have received a copy of the GNU General Public License     }
{ along with this program.  If not, see <http://www.gnu.org/licenses/>. }
{-----------------------------------------------------------------------}

// Nom Unite: U_Representant
// Date de creation : 23/08/2004
// Description : Gestion des representants physiques
//**************************************************************************
// Historique des modifications
// Modifi? le 22/03/05 par L.Brec
//    -> Gestion des affectations clients
/////////////////////////
unit U_Representant;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
{$IFNDEF FPC}
  JvComponent, JvExControls, JvDBLookup, AdvListV, RbSplitter, RXSplit, Mask,
{$ELSE}
  MaskEdit,
{$ENDIF}
  LCLType, Messages, Graphics, Controls, Classes, ExtCtrls,  Dialogs, DB, IBQuery,IBTable,IBUpdateSQL,
  U_ExtDBNavigator, Buttons, Forms, DBCtrls, Grids,
  DBGrids, u_framework_dbcomponents, ComCtrls, StdCtrls, SysUtils,  TypInfo,  Variants,
  StrUtils, U_FormDico, U_OnFormInfoIni,  JvXPButtons,
  u_framework_components, u_buttons_appli,
  U_ExtDBGrid, U_GroupView, ImgList,fonctions_variant;

type

  { TF_Repr }

  TF_Repr = class(TF_FormDico)
    nv_navigator: TExtDBNavigator;
    nv_saisie: TExtDBNavigator;
    lb_code: TFWLabel;
    lb_nom: TFWLabel;
    ed_code: TFWDBEdit;
    ed_nom: TFWDBEdit;
    pa_1: TPanel;
    pa_2: TPanel;
    pa_3: TPanel;
    pa_4: TPanel;
    pa_5: TPanel;
    pa_6: TPanel;
    SvgFormInfoIni: TOnFormInfoIni;
    spl_1: TSplitter;
    gd_repr: TExtDBGrid;
    lb_prenom: TFWLabel;
    ed_prenom: TFWDBEdit;
    lb_civilite: TFWLabel;
    pc_Infos: TPageControl;
    ts_generale: TTabSheet;
    lb_assist: TFWLabel;
    cbx_assist: TDBLookupComboBox;
    ed_adresse1: TFWDBEdit;
    lb_adresse: TFWLabel;
    ed_adresse2: TFWDBEdit;
    ed_adresse3: TFWDBEdit;
    lb_codepost: TFWLabel;
    ed_codepostal: TFWDBEdit;
    bt_cp: TJvXpButton;
    lb_ville: TFWLabel;
    ed_ville: TFWDBEdit;
    cbx_pays: TDBLookupComboBox;
    lb_pays: TFWLabel;
    lb_tel: TFWLabel;
    ed_tel: TFWDBEdit;
    lb_poste: TFWLabel;
    ed_poste: TFWDBEdit;
    lb_mobile: TFWLabel;
    ed_mobile: TFWDBEdit;
    ed_fax: TFWDBEdit;
    lb_fax: TFWLabel;
    lb_email: TFWLabel;
    ed_email: TFWDBEdit;
    ed_web: TFWDBEdit;
    lb_web: TFWLabel;
    ts_generale2: TTabSheet;
    lb_taux: TFWLabel;
    ed_taux: TFWDBEdit;
    ed_credit: TFWDBEdit;
    lb_credit: TFWLabel;
    lb_objca: TFWLabel;
    ed_objca: TFWDBEdit;
    mo_note: TDBMemo;
    lb_note: TFWLabel;
    cbx_civilite: TFWDBLookupCombo;
    bt_civilite: TJvXpButton;
    Panel3: TPanel;
    Panel11: TPanel;
    bt_apercu: TFWPreview;
    Panel4: TPanel;
    bt_imprimer: TFWPrint;
    Panel1: TPanel;
    Panel2: TPanel;
    bt_fermer: TFWClose;
    im_images: TImageList;
    TabSheet1: TTabSheet;
    Panel20: TPanel;
    Panel21: TPanel;
    nv_secteur: TExtDBNavigator;
    gd_secteur: TExtDBGrid;
    RbSplitter6: TSplitter;
    procedure F_FormDicoCreate(Sender: TObject);
    procedure F_FormDicoDataOnCancel(Sender: TObject);
    procedure F_FormDicoActivate(Sender: TObject);

  private
    { D?clarations priv?es }
    ts_Changing : TTabSheet ;

  public
    { D?clarations publiques }
    procedure p_initSecteur;
    procedure Loaded; override;
  end;

var
  F_Repr: TF_Repr;

implementation

uses U_DmDonn,
     U_CodePostal,
     fonctions_erreurs,
     fonctions_forms;

{$IFNDEF FPC}
  {$R *.dfm}
{$ELSE}
  {$R *.lfm}
{$ENDIF}

procedure TF_Repr.F_FormDicoCreate(Sender: TObject);
begin
   F_Repr := self;
end;


procedure TF_Repr.F_FormDicoDataOnCancel(Sender: TObject);
begin
  gd_repr     .Enabled := True;
  nv_navigator.Enabled := True;
  nv_saisie   .Enabled := True;
  pa_6        .Enabled := True;

end;

procedure TF_Repr.p_initSecteur;
begin
  if not M_Donn.zq_repr.fieldbyname('REPR_Clep').isNull then
    begin
       M_Donn.zq_secteur.Close;
       M_Donn.zq_secteur.Params.ParamByName('rep').Value := M_Donn.zq_repr.fieldbyname('REPR_Clep').AsString;
       M_Donn.zq_secteur.open;
    end;
end;

procedure TF_Repr.Loaded;
begin
  
  with DBSources.Add do
    Begin
      Table:='REPRESENTANT';
      Key.Add.FieldName :='REPR_Clep';
      Grid := gd_repr;
      NavEdit:=nv_saisie;
      Navigator:=nv_navigator;
      Panels.Add.Panel:=pa_6;
    end;
  inherited;
end;

procedure TF_Repr.F_FormDicoActivate(Sender: TObject);
begin
  p_initSecteur;
end;

end.

